/* Copyright 2007, 2012, 2015 Kevin Ryde.

   This file is part of x2gpm.

   x2gpm is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 3, or (at your option) any later
   version.

   x2gpm is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License along
   with X2gpm; see the file COPYING.  Failing that, goto
   <http://www.gnu.org/licenses/>. */

#define _GNU_SOURCE
#include <assert.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <getopt.h>
#include <limits.h>
#include <pwd.h>
#include <signal.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#include <utmp.h>
#include <sys/types.h>
#include <sys/poll.h>


int
main (void)
{
  printf("sizeof %d\n", sizeof(struct utmp));
  {
    struct utmp want;
    struct utmp *got;
    memset (&want, '\0', sizeof(want));
    char *option_display = ":0";
    strncpy (want.ut_line, "console", sizeof(want.ut_line));
    strncpy (want.ut_id, option_display, sizeof(want.ut_id));
    got = getutline (&want);
    printf ("%p\n", got);
    printf ("  type %d  pid %d line %s\n", got->ut_type, got->ut_pid, got->ut_line);
    printf ("  id %s  user %s line %s\n", got->ut_id, got->ut_user, got->ut_line);
  }
  return 0;
  {
    static struct utmp want;
    struct utmp *got;
    want.ut_type = USER_PROCESS;
    strcpy (want.ut_line, "/dev/tty6");
    got = getutline (&want);
    printf ("%p\n", got);
  }
  {
    static struct utmp want;
    struct utmp *got;
    want.ut_type = USER_PROCESS;
    want.ut_type = LOGIN_PROCESS;
    setutent();
    while ((got = getutid (&want))) {
      printf ("%p\n", got);
      printf ("  type %d  pid %d line %s\n", got->ut_type, got->ut_pid, got->ut_line);
      printf ("  id %s  user %s line %s\n", got->ut_id, got->ut_user, got->ut_line);
      int i;
      for (i=0; i < sizeof(*got); i++) {
        int c = (int) ((unsigned char *) got)[i];
        if (isprint(c)) {
          printf("%c", c);
        } else {
          printf("\\x%02X", c);
        }
      }
      printf("\n");
    }
    endutent();
  }
  {
    int fd = open("/var/run/utmp", O_RDONLY);
    struct utmp got;
    while (read(fd, &got, sizeof(got)) > 0) {
      printf ("type %d  pid %d line %s\n", got.ut_type, got.ut_pid, got.ut_line);
      printf ("  id %s  user %s line %s\n", got.ut_id, got.ut_user, got.ut_line);
      /* int i; */
      /* for (i=0; i < sizeof(*got); i++) { */
      /*   int c = (int) ((unsigned char *) got)[i]; */
      /*   if (isprint(c)) { */
      /*     printf("%c", c); */
      /*   } else { */
      /*     printf("\\x%02X", c); */
      /*   } */
      /* } */
      /* printf("\n"); */
    }
    endutent();
  }
  return 0;
}
